## qemu 6.2+dfsg

=== Makefile ===
# Makefile for QEMU.

ifneq ($(words $(subst :, ,$(CURDIR))), 1)
  $(error main directory cannot contain spaces nor colons)
endif

# Always point to the root of the build tree (needs GNU make).
BUILD_DIR=$(CURDIR)

# Before including a proper config-host.mak, assume we are in the source tree
SRC_PATH=.

# Don't use implicit rules or variables
# we have explicit rules for everything
MAKEFLAGS += -rR

SHELL = bash -o pipefail

# Usage: $(call quiet-command,command and args,"NAME","args to print")
# This will run "command and args", and either:
#  if V=1 just print the whole command and args
#  otherwise print the 'quiet' output in the format "  NAME     args to print"
# NAME should be a short name of the command, 7 letters or fewer.
# If called with only a single argument, will print nothing in quiet mode.
quiet-command-run = $(if $(V),,$(if $2,printf "  %-7s %s\n" $2 $3 && ))$1
quiet-@ = $(if $(V),,@)
quiet-command = $(quiet-@)$(call quiet-command-run,$1,$2,$3)

UNCHECKED_GOALS := %clean TAGS cscope ctags dist \
    help check-help print-% \
    docker docker-% vm-help vm-test vm-build-%

all:
.PHONY: all clean distclean recurse-all dist msi FORCE

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

# All following code might depend on configuration variables
ifneq ($(wildcard config-host.mak),)
include config-host.mak

git-submodule-update:
.git-submodule-status: git-submodule-update config-host.mak
Makefile: .git-submodule-status

.PHONY: git-submodule-update
git-submodule-update:
ifneq ($(GIT_SUBMODULES_ACTION),ignore)
	$(call quiet-command, \
		(GIT="$(GIT)" "$(SRC_PATH)/scripts/git-submodule.sh" $(GIT_SUBMODULES_ACTION) $(GIT_SUBMODULES)), \
		"GIT","$(GIT_SUBMODULES)")
endif

# 0. ensure the build tree is okay

# Check that we're not trying to do an out-of-tree build from
# a tree that's been used for an in-tree build.
ifneq ($(realpath $(SRC_PATH)),$(realpath .))
ifneq ($(wildcard $(SRC_PATH)/config-host.mak),)
$(error This is an out of tree build but your source tree ($(SRC_PATH)) \
seems to have been used for an in-tree build. You can fix this by running \
"$(MAKE) distclean && rm -rf *-linux-user *-softmmu" in your source tree)
endif
endif

# force a rerun of configure if config-host.mak is too old or corrupted
ifeq ($(MESON),)
.PHONY: config-host.mak
x := $(shell rm -rf meson-private meson-info meson-logs)
endif
ifeq ($(NINJA),)
.PHONY: config-host.mak
x := $(shell rm -rf meson-private meson-info meson-logs)
else
export NINJA
endif
ifeq ($(wildcard build.ninja),)
.PHONY: config-host.mak
x := $(shell rm -rf meson-private meson-info meson-logs)
endif
ifeq ($(origin prefix),file)
.PHONY: config-host.mak
x := $(shell rm -rf meson-private meson-info meson-logs)
endif

# 1. ensure config-host.mak is up-to-date
config-host.mak: $(SRC_PATH)/configure $(SRC_PATH)/scripts/meson-buildoptions.sh $(SRC_PATH)/pc-bios $(SRC_PATH)/VERSION
	@echo config-host.mak is out-of-date, running configure
	@if test -f meson-private/coredata.dat; then \
	  ./config.status --skip-meson; \
	else \
	  ./config.status && touch build.ninja.stamp; \
	fi

# 2. meson.stamp exists if meson has run at least once (so ninja reconfigure
# works), but otherwise never needs to be updated
meson-private/coredata.dat: meson.stamp
meson.stamp: config-host.mak
	@touch meson.stamp

# 3. ensure generated build files are up-to-date

ifneq ($(NINJA),)
Makefile.ninja: build.ninja
	$(quiet-@){ \
	  echo 'ninja-targets = \'; \
	  $(NINJA) -t targets all | sed 's/:.*//; $$!s/$$/ \\/'; \
	  echo 'build-files = \'; \
	  $(NINJA) -t query build.ninja | sed -n '1,/^  input:/d; /^  outputs:/q; s/$$/ \\/p'; \
	} > $@.tmp && mv $@.tmp $@
-include Makefile.ninja

# A separate rule is needed for Makefile dependencies to avoid -n
build.ninja: build.ninja.stamp
$(build-files):
build.ninja.stamp: meson.stamp $(build-files)
	$(NINJA) $(if $V,-v,) build.ninja && touch $@
endif

ifneq ($(MESON),)
Makefile.mtest: build.ninja scripts/mtest2make.py
	$(MESON) introspect --targets --tests --benchmarks | $(PYTHON) scripts/mtest2make.py > $@
-include Makefile.mtest

.PHONY: update-buildoptions
all update-buildoptions: $(SRC_PATH)/scripts/meson-buildoptions.sh
$(SRC_PATH)/scripts/meson-buildoptions.sh: $(SRC_PATH)/meson_options.txt
	$(MESON) introspect --buildoptions $(SRC_PATH)/meson.build | $(PYTHON) \
	  scripts/meson-buildoptions.py > $@.tmp && mv $@.tmp $@
endif

# 4. Rules to bridge to other makefiles

ifneq ($(NINJA),)
# Filter out long options to avoid flags like --no-print-directory which
# may result in false positive match for MAKE.n
MAKE.n = $(findstring n,$(firstword $(filter-out --%,$(MAKEFLAGS))))
MAKE.k = $(findstring k,$(firstword $(filter-out --%,$(MAKEFLAGS))))
MAKE.q = $(findstring q,$(firstword $(filter-out --%,$(MAKEFLAGS))))
MAKE.nq = $(if $(word 2, $(MAKE.n) $(MAKE.q)),nq)
NINJAFLAGS = $(if $V,-v) $(if $(MAKE.n), -n) $(if $(MAKE.k), -k0) \
        $(filter-out -j, $(lastword -j1 $(filter -l% -j%, $(MAKEFLAGS)))) \

ninja-cmd-goals = $(or $(MAKECMDGOALS), all)
ninja-cmd-goals += $(foreach t, $(.tests), $(.test.deps.$t))

makefile-targets := build.ninja ctags TAGS cscope dist clean uninstall
# "ninja -t targets" also lists all prerequisites.  If build system
# files are marked as PHONY, however, Make will always try to execute
# "ninja build.ninja".
ninja-targets := $(filter-out $(build-files) $(makefile-targets), $(ninja-targets))
.PHONY: $(ninja-targets) run-ninja
$(ninja-targets): run-ninja

# Use "| cat" to give Ninja a more "make-y" output.  Use "+" to bypass the
# --output-sync line.
run-ninja: config-host.mak
ifneq ($(filter $(ninja-targets), $(ninja-cmd-goals)),)
	+$(quiet-@)$(if $(MAKE.nq),@:, $(NINJA) -d keepdepfile \
	   $(NINJAFLAGS) $(sort $(filter $(ninja-targets), $(ninja-cmd-goals))) | cat)
endif
endif

# Force configure to re-run if the API symbols are updated
ifeq ($(CONFIG_PLUGIN),y)
config-host.mak: $(SRC_PATH)/plugins/qemu-plugins.symbols

.PHONY: plugins
plugins:
	$(call quiet-command,\
		$(MAKE) $(SUBDIR_MAKEFLAGS) -C contrib/plugins V="$(V)", \
		"BUILD", "example plugins")
endif # $(CONFIG_PLUGIN)

else # config-host.mak does not exist
config-host.mak:
ifneq ($(filter-out $(UNCHECKED_GOALS),$(MAKECMDGOALS)),$(if $(MAKECMDGOALS),,fail))
	@echo "Please call configure before running make!"
	@exit 1
endif
endif # config-host.mak does not exist

SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory --quiet)

include $(SRC_PATH)/tests/Makefile.include

all: recurse-all

ROM_DIRS = $(addprefix pc-bios/, $(ROMS))
ROM_DIRS_RULES=$(foreach t, all clean, $(addsuffix /$(t), $(ROM_DIRS)))
# Only keep -O and -g cflags
.PHONY: $(ROM_DIRS_RULES)
$(ROM_DIRS_RULES):
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $(dir $@) V="$(V)" TARGET_DIR="$(dir $@)" $(notdir $@),)

.PHONY: recurse-all recurse-clean
recurse-all: $(addsuffix /all, $(ROM_DIRS))
recurse-clean: $(addsuffix /clean, $(ROM_DIRS))

######################################################################

clean: recurse-clean
	-$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean || :
	-$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) clean-ctlist || :
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	find . \( -name '*.so' -o -name '*.dll' -o -name '*.[oda]' \) -type f \
		! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-aarch64.a \
		! -path ./roms/edk2/ArmPkg/Library/GccLto/liblto-arm.a \
		-exec rm {} +
	rm -f TAGS cscope.* *.pod *~ */*~
	rm -f fsdev/*.pod scsi/*.pod

VERSION = $(shell cat $(SRC_PATH)/VERSION)

dist: qemu-$(VERSION).tar.bz2

qemu-%.tar.bz2:
	$(SRC_PATH)/scripts/make-release "$(SRC_PATH)" "$(patsubst qemu-%.tar.bz2,%,$@)"

distclean: clean
	-$(quiet-@)test -f build.ninja && $(NINJA) $(NINJAFLAGS) -t clean -g || :
	rm -f config-host.mak config-host.h* config-poison.h
	rm -f tests/tcg/config-*.mak
	rm -f config-all-disas.mak config.status
	rm -f roms/seabios/config.mak roms/vgabios/config.mak
	rm -f qemu-plugins-ld.symbols qemu-plugins-ld64.symbols
	rm -f *-config-target.h *-config-devices.mak *-config-devices.h
	rm -rf meson-private meson-logs meson-info compile_commands.json
	rm -f Makefile.ninja Makefile.mtest build.ninja.stamp meson.stamp
	rm -f config.log
	rm -f linux-headers/asm
	rm -Rf .sdk

find-src-path = find "$(SRC_PATH)" -path "$(SRC_PATH)/meson" -prune -o \
	-type l -prune -o \( -name "*.[chsS]" -o -name "*.[ch].inc" \)

.PHONY: ctags
ctags:
	$(call quiet-command, 			\
		rm -f "$(SRC_PATH)/"tags, 	\
		"CTAGS", "Remove old tags")
	$(call quiet-command, \
		$(find-src-path) -exec ctags 		\
		-f "$(SRC_PATH)/"tags --append {} +,	\
		"CTAGS", "Re-index $(SRC_PATH)")

.PHONY: gtags
gtags:
	$(call quiet-command, 			\
		rm -f "$(SRC_PATH)/"GTAGS; 	\
		rm -f "$(SRC_PATH)/"GRTAGS; 	\
		rm -f "$(SRC_PATH)/"GPATH, 	\
		"GTAGS", "Remove old $@ files")
	$(call quiet-command, 				\
	        (cd $(SRC_PATH) && 			\
		 $(find-src-path) -print | gtags -f -),	\
		"GTAGS", "Re-index $(SRC_PATH)")

.PHONY: TAGS
TAGS:
	$(call quiet-command, 			\
		rm -f "$(SRC_PATH)/"TAGS,	\
		"TAGS", "Remove old $@")
	$(call quiet-command, 				\
		$(find-src-path) -exec etags 		\
		-f "$(SRC_PATH)/"TAGS --append {} +, 	\
		"TAGS", "Re-index $(SRC_PATH)")

.PHONY: cscope
cscope:
	$(call quiet-command,			\
		rm -f "$(SRC_PATH)/"cscope.* ,	\
		"cscope", "Remove old $@ files")
	$(call quiet-command, 					\
		($(find-src-path) -print | sed -e 's,^\./,,'    \
		> "$(SRC_PATH)/cscope.files"), 			\
		"cscope", "Create file list")
	$(call quiet-command, 				\
		cscope -b -i"$(SRC_PATH)/cscope.files" 	\
		-f"$(SRC_PATH)"/cscope.out, 		\
		"cscope", "Re-index $(SRC_PATH)")

# Needed by "meson install"
export DESTDIR

include $(SRC_PATH)/tests/docker/Makefile.include
include $(SRC_PATH)/tests/vm/Makefile.include

print-help-run = printf "  %-30s - %s\\n" "$1" "$2"
print-help = @$(call print-help-run,$1,$2)

.PHONY: help
help:
	@echo  'Generic targets:'
	$(call print-help,all,Build all)
	$(call print-help,dir/file.o,Build specified target only)
	$(call print-help,install,Install QEMU, documentation and tools)
	$(call print-help,ctags/gtags/TAGS,Generate tags file for editors)
	$(call print-help,cscope,Generate cscope index)
	$(call print-help,sparse,Run sparse on the QEMU source)
	@echo  ''
ifeq ($(CONFIG_PLUGIN),y)
	@echo  'Plugin targets:'
	$(call print-help,plugins,Build the example TCG plugins)
	@echo  ''
endif
	@echo  'Cleaning targets:'
	$(call print-help,clean,Remove most generated files but keep the config)
	$(call print-help,distclean,Remove all generated files)
	$(call print-help,dist,Build a distributable tarball)
	@echo  ''
	@echo  'Test targets:'
	$(call print-help,check,Run all tests (check-help for details))
	$(call print-help,bench,Run all benchmarks)
	$(call print-help,docker-help,Help about targets running tests inside containers)
	$(call print-help,vm-help,Help about targets running tests inside VM)
	@echo  ''
	@echo  'Documentation targets:'
	$(call print-help,html man,Build documentation in specified format)
	@echo  ''
ifdef CONFIG_WIN32
	@echo  'Windows targets:'
	$(call print-help,installer,Build NSIS-based installer for QEMU)
	$(call print-help,msi,Build MSI-based installer for qemu-ga)
	@echo  ''
endif
	$(call print-help,$(MAKE) [targets],(quiet build, default))
	$(call print-help,$(MAKE) V=1 [targets],(verbose build))

# will delete the target of a rule if commands exit with a nonzero exit status
.DELETE_ON_ERROR:

print-%:
	@echo '$*=$($*)'

=== meson_options.txt ===
# These options do not correspond to a --enable/--disable-* option
# on the configure script command line.  If you add more, list them in
# scripts/meson-buildoptions.py's SKIP_OPTIONS constant too.

option('qemu_suffix', type : 'string', value: 'qemu',
       description: 'Suffix for QEMU data/modules/config directories (can be empty)')
option('docdir', type : 'string', value : 'doc',
       description: 'Base directory for documentation installation (can be empty)')
option('qemu_firmwarepath', type : 'string', value : '',
       description: 'search PATH for firmware files')
option('sphinx_build', type : 'string', value : '',
       description: 'Use specified sphinx-build [$sphinx_build] for building document (default to be empty)')
option('default_devices', type : 'boolean', value : true,
       description: 'Include a default selection of devices in emulators')
option('audio_drv_list', type: 'array', value: ['default'],
       choices: ['alsa', 'coreaudio', 'default', 'dsound', 'jack', 'oss', 'pa', 'sdl'],
       description: 'Set audio driver list')
option('fuzzing_engine', type : 'string', value : '',
       description: 'fuzzing engine library for OSS-Fuzz')
option('trace_file', type: 'string', value: 'trace',
       description: 'Trace file prefix for simple backend')

# Everything else can be set via --enable/--disable-* option
# on the configure script command line.  After adding an option
# here make sure to run "make update-buildoptions".

option('docs', type : 'feature', value : 'auto',
       description: 'Documentations build support')
option('fuzzing', type : 'boolean', value: false,
       description: 'build fuzzing targets')
option('gettext', type : 'feature', value : 'auto',
       description: 'Localization of the GTK+ user interface')
option('install_blobs', type : 'boolean', value : true,
       description: 'install provided firmware blobs')
option('sparse', type : 'feature', value : 'auto',
       description: 'sparse checker')
option('guest_agent_msi', type : 'feature', value : 'auto',
       description: 'Build MSI package for the QEMU Guest Agent')

option('malloc_trim', type : 'feature', value : 'auto',
       description: 'enable libc malloc_trim() for memory optimization')
option('malloc', type : 'combo', choices : ['system', 'tcmalloc', 'jemalloc'],
       value: 'system', description: 'choose memory allocator to use')

option('kvm', type: 'feature', value: 'auto',
       description: 'KVM acceleration support')
option('hax', type: 'feature', value: 'auto',
       description: 'HAX acceleration support')
option('whpx', type: 'feature', value: 'auto',
       description: 'WHPX acceleration support')
option('hvf', type: 'feature', value: 'auto',
       description: 'HVF acceleration support')
option('nvmm', type: 'feature', value: 'auto',
       description: 'NVMM acceleration support')
option('xen', type: 'feature', value: 'auto',
       description: 'Xen backend support')
option('xen_pci_passthrough', type: 'feature', value: 'auto',
       description: 'Xen PCI passthrough support')
option('tcg', type: 'feature', value: 'auto',
       description: 'TCG support')
option('tcg_interpreter', type: 'boolean', value: false,
       description: 'TCG with bytecode interpreter (slow)')
option('cfi', type: 'boolean', value: 'false',
       description: 'Control-Flow Integrity (CFI)')
option('cfi_debug', type: 'boolean', value: 'false',
       description: 'Verbose errors in case of CFI violation')
option('multiprocess', type: 'feature', value: 'auto',
       description: 'Out of process device emulation support')

option('attr', type : 'feature', value : 'auto',
       description: 'attr/xattr support')
option('auth_pam', type : 'feature', value : 'auto',
       description: 'PAM access control')
option('brlapi', type : 'feature', value : 'auto',
       description: 'brlapi character device driver')
option('bzip2', type : 'feature', value : 'auto',
       description: 'bzip2 support for DMG images')
option('cap_ng', type : 'feature', value : 'auto',
       description: 'cap_ng support')
option('bpf', type : 'feature', value : 'auto',
        description: 'eBPF support')
option('cocoa', type : 'feature', value : 'auto',
       description: 'Cocoa user interface (macOS only)')
option('curl', type : 'feature', value : 'auto',
       description: 'CURL block device driver')
option('glusterfs', type : 'feature', value : 'auto',
       description: 'Glusterfs block device driver')
option('libiscsi', type : 'feature', value : 'auto',
       description: 'libiscsi userspace initiator')
option('libnfs', type : 'feature', value : 'auto',
       description: 'libnfs block device driver')
option('mpath', type : 'feature', value : 'auto',
       description: 'Multipath persistent reservation passthrough')
option('iconv', type : 'feature', value : 'auto',
       description: 'Font glyph conversion support')
option('curses', type : 'feature', value : 'auto',
       description: 'curses UI')
option('gnutls', type : 'feature', value : 'auto',
       description: 'GNUTLS cryptography support')
option('nettle', type : 'feature', value : 'auto',
       description: 'nettle cryptography support')
option('gcrypt', type : 'feature', value : 'auto',
       description: 'libgcrypt cryptography support')
option('libdaxctl', type : 'feature', value : 'auto',
       description: 'libdaxctl support')
option('libpmem', type : 'feature', value : 'auto',
       description: 'libpmem support')
option('libudev', type : 'feature', value : 'auto',
       description: 'Use libudev to enumerate host devices')
option('libusb', type : 'feature', value : 'auto',
       description: 'libusb support for USB passthrough')
option('libxml2', type : 'feature', value : 'auto',
       description: 'libxml2 support for Parallels image format')
option('linux_aio', type : 'feature', value : 'auto',
       description: 'Linux AIO support')
option('linux_io_uring', type : 'feature', value : 'auto',
       description: 'Linux io_uring support')
option('lzfse', type : 'feature', value : 'auto',
       description: 'lzfse support for DMG images')
option('lzo', type : 'feature', value : 'auto',
       description: 'lzo compression support')
option('rbd', type : 'feature', value : 'auto',
       description: 'Ceph block device driver')
option('gtk', type : 'feature', value : 'auto',
       description: 'GTK+ user interface')
option('sdl', type : 'feature', value : 'auto',
       description: 'SDL user interface')
option('sdl_image', type : 'feature', value : 'auto',
       description: 'SDL Image support for icons')
option('seccomp', type : 'feature', value : 'auto',
       description: 'seccomp support')
option('smartcard', type : 'feature', value : 'auto',
       description: 'CA smartcard emulation support')
option('snappy', type : 'feature', value : 'auto',
       description: 'snappy compression support')
option('spice', type : 'feature', value : 'auto',
       description: 'Spice server support')
option('spice_protocol', type : 'feature', value : 'auto',
       description: 'Spice protocol support')
option('u2f', type : 'feature', value : 'auto',
       description: 'U2F emulation support')
option('usb_redir', type : 'feature', value : 'auto',
       description: 'libusbredir support')
option('l2tpv3', type : 'feature', value : 'auto',
       description: 'l2tpv3 network backend support')
option('netmap', type : 'feature', value : 'auto',
       description: 'netmap network backend support')
option('vde', type : 'feature', value : 'auto',
       description: 'vde network backend support')
option('virglrenderer', type : 'feature', value : 'auto',
       description: 'virgl rendering support')
option('vnc', type : 'feature', value : 'auto',
       description: 'VNC server')
option('vnc_jpeg', type : 'feature', value : 'auto',
       description: 'JPEG lossy compression for VNC server')
option('vnc_png', type : 'feature', value : 'auto',
       description: 'PNG compression for VNC server')
option('vnc_sasl', type : 'feature', value : 'auto',
       description: 'SASL authentication for VNC server')
option('vte', type : 'feature', value : 'auto',
       description: 'vte support for the gtk UI')
option('xkbcommon', type : 'feature', value : 'auto',
       description: 'xkbcommon support')
option('zstd', type : 'feature', value : 'auto',
       description: 'zstd compression support')
option('fuse', type: 'feature', value: 'auto',
       description: 'FUSE block device export')
option('fuse_lseek', type : 'feature', value : 'auto',
       description: 'SEEK_HOLE/SEEK_DATA support for FUSE exports')

option('trace_backends', type: 'array', value: ['log'],
       choices: ['dtrace', 'ftrace', 'log', 'nop', 'simple', 'syslog', 'ust'],
       description: 'Set available tracing backends')

option('alsa', type: 'feature', value: 'auto',
       description: 'ALSA sound support')
option('coreaudio', type: 'feature', value: 'auto',
       description: 'CoreAudio sound support')
option('dsound', type: 'feature', value: 'auto',
       description: 'DirectSound sound support')
option('jack', type: 'feature', value: 'auto',
       description: 'JACK sound support')
option('oss', type: 'feature', value: 'auto',
       description: 'OSS sound support')
option('pa', type: 'feature', value: 'auto',
       description: 'PulseAudio sound support')

option('vhost_user_blk_server', type: 'feature', value: 'auto',
       description: 'build vhost-user-blk server')
option('virtfs', type: 'feature', value: 'auto',
       description: 'virtio-9p support')
option('virtiofsd', type: 'feature', value: 'auto',
       description: 'build virtiofs daemon (virtiofsd)')

option('capstone', type: 'combo', value: 'auto',
       choices: ['disabled', 'enabled', 'auto', 'system', 'internal'],
       description: 'Whether and how to find the capstone library')
option('slirp', type: 'combo', value: 'auto',
       choices: ['disabled', 'enabled', 'auto', 'system', 'internal'],
       description: 'Whether and how to find the slirp library')
option('fdt', type: 'combo', value: 'auto',
       choices: ['disabled', 'enabled', 'auto', 'system', 'internal'],
       description: 'Whether and how to find the libfdt library')

option('selinux', type: 'feature', value: 'auto',
       description: 'SELinux support in qemu-nbd')

=== contrib/plugins/Makefile ===
# -*- Mode: makefile -*-
#
# This Makefile example is fairly independent from the main makefile
# so users can take and adapt it for their build. We only really
# include config-host.mak so we don't have to repeat probing for
# cflags that the main configure has already done for us.
#

BUILD_DIR := $(CURDIR)/../..

include $(BUILD_DIR)/config-host.mak

VPATH += $(SRC_PATH)/contrib/plugins

NAMES :=
NAMES += execlog
NAMES += hotblocks
NAMES += hotpages
NAMES += howvec
NAMES += lockstep
NAMES += hwprofile
NAMES += cache

SONAMES := $(addsuffix .so,$(addprefix lib,$(NAMES)))

# The main QEMU uses Glib extensively so it's perfectly fine to use it
# in plugins (which many example do).
CFLAGS = $(GLIB_CFLAGS)
CFLAGS += -fPIC -Wall $(filter -W%, $(QEMU_CFLAGS))
CFLAGS += $(if $(findstring no-psabi,$(QEMU_CFLAGS)),-Wpsabi)
CFLAGS += -I$(SRC_PATH)/include/qemu

all: $(SONAMES)

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

lib%.so: %.o
	$(CC) -shared -Wl,-soname,$@ -o $@ $^ $(LDLIBS)

clean:
	rm -f *.o *.so *.d
	rm -Rf .libs

.PHONY: all clean

=== pc-bios/vof/Makefile ===
all: build-all

build-all: vof.bin

CROSS ?=
CC = $(CROSS)gcc
LD = $(CROSS)ld
OBJCOPY = $(CROSS)objcopy

%.o: %.S
	$(CC) -m32 -mbig-endian -mcpu=power4 -c -o $@ $<

%.o: %.c
	$(CC) -m32 -mbig-endian -mcpu=power4 -c -fno-stack-protector -o $@ $<

vof.elf: entry.o main.o ci.o bootmem.o libc.o
	$(LD) -nostdlib -e_start -Tvof.lds -EB -o $@ $^

%.bin: %.elf
	$(OBJCOPY) -O binary -j .text -j .data -j .toc -j .got2 $^ $@

clean:
	rm -f *.o vof.bin vof.elf *~

=== roms/skiboot/Makefile ===
# SPDX-License-Identifier: Apache-2.0 OR GPL-2.0-or-later
# Copyright 2012-2019 IBM Corp

#
# If you want to build in another directory copy this file there and
# fill in the following values
#

#
# Prefix of cross toolchain, if anything
# Example: CROSS= powerpc64-unknown-linux-gnu-
#
ARCH = $(shell uname -m)
ifdef CROSS_COMPILE
	CROSS ?= $(CROSS_COMPILE)
endif
ifneq ("$(ARCH)", "ppc64")
ifneq ("$(ARCH)", "ppc64le")
ifneq ($(shell which powerpc64-linux-gcc 2> /dev/null),)
	CROSS ?= powerpc64-linux-
else ifneq ($(shell which powerpc64le-linux-gcc 2> /dev/null),)
	CROSS ?= powerpc64le-linux-
else ifneq ($(shell which powerpc64-linux-gnu-gcc 2> /dev/null),)
	CROSS ?= powerpc64-linux-gnu-
else ifneq ($(shell which powerpc64le-linux-gnu-gcc 2> /dev/null),)
	CROSS ?= powerpc64le-linux-gnu-
endif
endif
endif

#
# Main debug switch
#
DEBUG ?= 0

# Run tests under valgrind?
USE_VALGRIND ?= 1

#
# Optional location of embedded linux kernel file
# This can be a raw vmlinux, stripped vmlinux or
# zImage.epapr
#
KERNEL ?=

#
# Optional build with advanced stack checking
#
STACK_CHECK ?= $(DEBUG)

#
# Experimental (unsupported) build options
#
# Little-endian does not yet build. Include it here to set ELF ABI.
LITTLE_ENDIAN ?= 0
# ELF v2 ABI is more efficient and compact
ELF_ABI_v2 ?= $(LITTLE_ENDIAN)
# Discard unreferenced code and data at link-time
DEAD_CODE_ELIMINATION ?= 0
# Try to build without FSP code
CONFIG_FSP?=1

#
# Where is the source directory, must be a full path (no ~)
# Example: SRC= /home/me/skiboot
#
SRC=$(CURDIR)

#
# Where to get information about this machine (subdir name)
#
DEVSRC=hdata

#
# default config file, see include config_*.h for more specifics
#
CONFIG := config.h

include $(SRC)/Makefile.main

=== roms/u-boot-sam460ex/arch/powerpc/cpu/mpc86xx/Makefile ===
#
# Copyright 2007 Freescale Semiconductor, Inc.
# (C) Copyright 2002,2003 Motorola Inc.
# Xianghua Xiao,X.Xiao@motorola.com
#
# (C) Copyright 2004 Freescale Semiconductor. (MC86xx Port)
# Jeff Brown
# See file CREDITS for list of people who contributed to this
# project.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#

include $(TOPDIR)/config.mk

LIB	= $(obj)lib$(CPU).a

START	= start.o

SOBJS-y += cache.o
SOBJS-$(CONFIG_MP) += release.o

COBJS-y	+= cpu.o
COBJS-y	+= cpu_init.o
# 8610 & 8641 are identical w/regards to DDR
COBJS-$(CONFIG_MPC8610) += ddr-8641.o
COBJS-$(CONFIG_MPC8641) += ddr-8641.o
COBJS-$(CONFIG_OF_LIBFDT) += fdt.o
COBJS-y	+= interrupts.o
COBJS-$(CONFIG_MP) += mp.o
COBJS-y	+= speed.o
COBJS-y	+= traps.o

SRCS	:= $(START:.o=.S) $(SOBJS-y:.o=.S) $(COBJS-y:.o=.c)
OBJS	:= $(addprefix $(obj),$(SOBJS-y) $(COBJS-y))
START	:= $(addprefix $(obj),$(START))

all:	$(obj).depend $(START) $(LIB)

$(LIB):	$(OBJS)
	$(AR) $(ARFLAGS) $@ $(ASOBJS) $(OBJS)

#########################################################################

# defines $(obj).depend target
include $(SRCTREE)/rules.mk

sinclude $(obj).depend

#########################################################################

=== roms/u-boot-sam460ex/arch/arm/cpu/arm_cortexa8/mx51/Makefile ===
#
# (C) Copyright 2000-2006
# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
#
# (C) Copyright 2009 Freescale Semiconductor, Inc.
#
# See file CREDITS for list of people who contributed to this
# project.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA
#

include $(TOPDIR)/config.mk

LIB	= $(obj)lib$(SOC).a

COBJS	= soc.o clock.o iomux.o timer.o speed.o
SOBJS = lowlevel_init.o

SRCS	:= $(SOBJS:.o=.S) $(COBJS:.o=.c)
OBJS	:= $(addprefix $(obj),$(SOBJS) $(COBJS))

all:	$(obj).depend $(LIB)

$(LIB):	$(OBJS)
	$(AR) $(ARFLAGS) $@ $(OBJS)

#########################################################################

# defines $(obj).depend target
include $(SRCTREE)/rules.mk

sinclude $(obj).depend

#########################################################################

=== debian/changelog ===
qemu (1:6.2+dfsg-2ubuntu6.27) jammy-security; urgency=medium

  * SECURITY UPDATE: double-free in QEMU virtio devices
    - debian/patches/CVE-2024-3446-pre1.patch: add an optional reentrancy
      guard to the BH API in docs/devel/multiple-iothreads.txt,
      include/block/aio.h, include/qemu/main-loop.h,
      tests/unit/ptimer-test-stubs.c, util/async.c, util/main-loop.c,
      util/trace-events.
    - debian/patches/CVE-2024-3446-pre2.patch: replace most qemu_bh_new
      calls with qemu_bh_new_guarded.
    - debian/patches/CVE-2024-3446-pre3.patch: introduce
      virtio_bh_new_guarded() helper in hw/virtio/virtio.c,
      include/hw/virtio/virtio.h.
    - debian/patches/CVE-2024-3446-1.patch: protect from DMA re-entrancy
      bugs in hw/virtio/virtio-crypto.c.
    - debian/patches/CVE-2024-3446-2.patch: protect from DMA re-entrancy
      bugs in hw/char/virtio-serial-bus.c.
    - debian/patches/CVE-2024-3446-3.patch: protect from DMA re-entrancy
      bugs in hw/display/virtio-gpu.c.
    - CVE-2024-3446
  * SECURITY UPDATE: heap overflow in SDHCI device emulation
    - debian/patches/CVE-2024-3447.patch: do not update TRNMOD when Command
      Inhibit (DAT) is set in hw/sd/sdhci.c.
    - CVE-2024-3447
  * SECURITY UPDATE: resource consumption in disk utility
    - debian/patches/CVE-2024-4467-pre1.patch: do not reopen data_file in
      invalidate_cache in block/qcow2.c.
    - debian/patches/CVE-2024-4467-1.patch: don't open data_file with
      BDRV_O_NO_IO in block/qcow2.c, tests/qemu-iotests/061*.
    - debian/patches/CVE-2024-4467-2.patch: don't store data-file with
      protocol in image in tests/qemu-iotests/244.
    - debian/patches/CVE-2024-4467-3.patch: don't store data-file with
      json: prefix in image in tests/qemu-iotests/270.
    - debian/patches/CVE-2024-4467-4.patch: parse filenames only when
      explicitly requested in block.c.
    - CVE-2024-4467
  * SECURITY UPDATE: heap overflow in virtio-net device RSS feature
    - debian/patches/CVE-2024-6505.patch: ensure queue index fits with RSS
      in hw/net/virtio-net.c.
    - CVE-2024-6505
  * SECURITY UPDATE: Dos via improper synchronization during socket closure
    - debian/patches/CVE-2024-7409-1.patch: plumb in new args to
      nbd_client_add() in blockdev-nbd.c, include/block/nbd.h,
      nbd/server.c, qemu-nbd.c.
    - debian/patches/CVE-2024-7409-2.patch: cap default max-connections to
      100 in block/monitor/block-hmp-cmds.c, blockdev-nbd.c,
      include/block/nbd.h, qapi/block-export.json.
    - debian/patches/CVE-2024-7409-3.patch: close stray clients at
      server-stop in blockdev-nbd.c.
    - debian/patches/CVE-2024-7409-4.patch: drop non-negotiating clients in
      nbd/server.c, nbd/trace-events.
    - debian/patches/CVE-2024-7409-5.patch: avoid use-after-free when
      closing server in blockdev-nbd.c.
    - CVE-2024-7409
  * SECURITY UPDATE: DoS via assert failure in usb_ep_get()
    - debian/patches/CVE-2024-8354.patch: change ohci validation in
      hw/usb/hcd-ohci.c, hw/usb/trace-events.
    - CVE-2024-8354
  * SECURITY UPDATE: possibly binfmt privilege escalation (LP: #2120814)
    - debian/binfmt-install: stop using C (Credentials) flag for
      binfmt_misc registration.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 25 Aug 2025 19:16:14 -0400

qemu (1:6.2+dfsg-2ubuntu6.26) jammy; urgency=medium

  [ Christian Ehrhardt ]
  * d/p/u/lp-2098896-hw-nvme-fix-narrowing-conversion.patch:
    Fix nvme devices >= 1 TiB in size (LP: #2098896)
    Thanks to Ryan Harper for the report, bisect and preparation!
  * d/p/u/lp-2019967-*: Add Rome types with updated cache info (LP: #2019967)

 -- Lukas Märdian <slyon@ubuntu.com>  Wed, 05 Mar 2025 11:48:26 +0100

qemu (1:6.2+dfsg-2ubuntu6.25) jammy; urgency=medium

  * d/p/u/lp-2019968-add-missing-feature-bits-epyc-milan-*.patch: Add
    missing feature bits to EPYC-Milan CPU model. (LP: #2019968)

  [ Louis Bouchard ]
  * d/p/monitor-only-run-coroutine-commands-in-qemu_aio_cont.patch:
    Backport upstream fix for qmp timeouts.
    Upstream commit effd60c878176bcaf97fa7ce2b12d04bb8ead6f7
    (LP: #2091013)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 29 Jan 2025 13:30:23 -0500

qemu (1:6.2+dfsg-2ubuntu6.24) jammy-security; urgency=medium

  * SECURITY UPDATE: denial of service
    - debian/patches/CVE-2023-3019-pre1.patch: Add definition for
      MemReentrancyGuard struct and add to DeviceState struct
    - debian/patches/CVE-2023-3019-1.patch: Provide MemReentrancyGuard * 
      to qemu_new_nic()
    - debian/patches/CVE-2023-3019-2.patch: Update MemReentrancyGuard for
      NIC
    - CVE-2023-3019

 -- Bruce Cable <bruce.cable@canonical.com>  Tue, 22 Oct 2024 16:33:28 +1100

qemu (1:6.2+dfsg-2ubuntu6.23) jammy; urgency=medium

  * Implement support for secure execution guest dump encryption with
    customer keys on s390x. (LP: #1959966)
    - d/p/u/lp1959966-kvm-secure-guest-exec-*.patch: Backport upstream
      patches to implement feature.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 20 Aug 2024 14:35:13 -0400

qemu (1:6.2+dfsg-2ubuntu6.22) jammy-security; urgency=medium

  * SECURITY UPDATE: null dereference
    - debian/patches/CVE-2023-6683-1.patch: Check size before
      populating info->types data
    - debian/patches/CVE-2023-6683-2.patch: Check clipboard types
      for if a callback needs to be set
    - CVE-2023-6683
  * SECURITY UPDATE: stack based buffer overflow
    - debian/patches/CVE-2023-6693.patch: Correctly copy vnet header 
      when flushing TX
    - CVE-2023-6693
  * SECURITY UPDATE: integer underflow
    - debian/patches/CVE-2024-24474.patch: Restrict non-DMA transfer 
      length to that of available data
    - CVE-2024-24474

 -- Bruce Cable <bruce.cable@canonical.com>  Thu, 01 Aug 2024 13:08:05 +1000

qemu (1:6.2+dfsg-2ubuntu6.21) jammy-security; urgency=medium

  * SECURITY REGRESSION: 9pfs restrictions on sockets (LP: #2065579)


=== debian/control ===
# autogenerated file, please edit debian/control-in
Source: qemu
Section: otherosfs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Riku Voipio <riku.voipio@iki.fi>,
	Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 12),
# In comments below we also specify (system-specific) arguments
# to qemu's configure script, -- optional features which depend
# on build-dependencies.
 python3:any,
 ninja-build, meson (>> 0.59.3~),
# --enable-docs
# for python3-sphinx:native see #995622
 texinfo, python3-sphinx:native, python3-sphinx-rtd-theme,
# iasl (from acpica-tools) is used only in a single test these days, not for building
# acpica-tools,
# libcapstone is in universe in ubuntu
# --enable-linux-aio	linux-*
 libaio-dev [linux-any],
 libjack-dev [linux-any],
# --audio-drv-list=pa,alsa,jack,oss,sdl	linux-*
# --audio-drv-list=pa,oss	kfreebsd-*
 libpulse-dev,
 libasound2-dev [linux-any],
# for virtfs (now in libc6)
# --enable-attr
# --enable-brlapi
 libbrlapi-dev,
# --enable-virtfs	linux-*
# needed for virtfs
# --enable-cap-ng	linux-*
 libcap-ng-dev [linux-any],
# --enable-curl
 libcurl4-gnutls-dev,
# --enable-fdt
# libfdt #931046
 libfdt-dev (>> 1.5.0-2~),
# --enable-fuse
 libfuse3-dev,
# --enable-gnutls
 gnutls-dev,
# --enable-gtk --enable-vte
 libgtk-3-dev, libvte-2.91-dev,
# --enable-libiscsi
 libiscsi-dev (>> 1.9.0~),
# --enable-curses
 libncurses-dev,
# --enable-virglrenderer	linux-*
 libvirglrenderer-dev [linux-any],
# --enable-opengl	linux-*
 libepoxy-dev [linux-any], libdrm-dev [linux-any], libgbm-dev [linux-any],
# --enable-numa	i386|amd64|ia64|mips|mipsel|powerpc|powerpcspe|x32|ppc64|ppc64el|arm64|sparc|s390x|riscv64
 libnuma-dev   [i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64],
# --enable-smartcard
 libcacard-dev,
 libpixman-1-dev,
# --enable-rbd		amd64|arm64|armel|armhf|i386|mips64el|mipsel|ppc64el|s390x|ppc64|sparc64
 librbd-dev            [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64 sparc64],
# before buster it was glusterfs-common so keep it for now for bpo
# --enable-glusterfs	linux-any
 libglusterfs-dev [linux-any] | glusterfs-common [linux-any],
# --enable-vnc-sasl
 libsasl2-dev,
# --enable-sdl
 libsdl2-dev,
# --enable-seccomp	amd64|arm64|armel|armhf|i386|mips64el|mipsel|ppc64el|s390x|hppa|powerpc|ppc64|riscv64|x32
 libseccomp-dev        [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x hppa powerpc ppc64 riscv64 x32],
# --enable-slirp=system
 libslirp-dev,
# --enable-spice	 linux-amd64|linux-i386|linux-arm64|linux-armel|linux-armhf|linux-mips64el|linux-mipsel|ppc64el|sh4|x32
 libspice-server-dev	[linux-amd64 linux-i386 linux-arm64 linux-armel linux-armhf linux-mips64el linux-mipsel ppc64el sh4 x32],
# --enable-rdma		linux-*
 librdmacm-dev [linux-any], libibverbs-dev [linux-any], libibumad-dev [linux-any],
# --enable-linux-io-uring	linux-*
 liburing-dev [linux-any],
# --enable-libusb	linux-*
 libusb-1.0-0-dev [linux-any],
# --enable-usb-redir	linux-*
 libusbredirparser-dev [linux-any],
# --enable-libssh
 libssh-dev,
# --enable-zstd
 libzstd-dev,
# vde is debian-only since ubuntu/vde2 is in universe
 libxen-dev [linux-amd64 linux-i386],
# --enable-nettle
 nettle-dev,
## always enabled: --enable-uuid
 uuid-dev,
# --enable-xfsctl	linux-*
 xfslibs-dev [linux-any],
# always needed
 zlib1g-dev,
# other optional features we enable
# --enable-libudev
# needed for qga?
 libudev-dev [linux-any],
# --enable-vnc
# --enable-vnc-jpeg
 libjpeg-dev,
# --enable-vnc-png
 libpng-dev,
# --enable-libpmem	linux-amd64|linux-arm64
 libpmem-dev [linux-amd64 linux-arm64],
# --enable-kvm		linux-*
# --enable-vhost-net	linux-*	# is it really linux-specific?
##--enable-lzo todo, for (memory) dumps
##--enable-netmap todo bsd
##--enable-xen-pci-passthrough todo
##--with-iconv (libiconv for curses wide char support)
## auth-pam - for auth for vnc&Co using PAM
## gio-2.0 - for -display=spice-app
Build-Depends-Indep:
# pc-bios/*.dts => *.dtb (PPC firmware)
 device-tree-compiler,
 gcc-s390x-linux-gnu,
# libc6.1-dev-alpha-cross isn't really needed but the code,
# for whatever reason, #include's string.h which needs libc6.1-dev
 gcc-alpha-linux-gnu, libc6.1-dev-alpha-cross,
# skiboot firmware, openbios
 gcc-powerpc64-linux-gnu,
# openbios
 gcc-sparc64-linux-gnu, fcode-utils, xsltproc,
# hppa-firmware
 gcc-hppa-linux-gnu,
# opensbi
 gcc-riscv64-linux-gnu,
Build-Conflicts: oss4-dev
Standards-Version: 4.5.1
Homepage: http://www.qemu.org/
XS-Debian-Vcs-Browser: https://salsa.debian.org/qemu-team/qemu
XS-Debian-Vcs-Git: https://salsa.debian.org/qemu-team/qemu.git
Vcs-Browser: https://git.launchpad.net/ubuntu/+source/qemu
Vcs-Git: https://git.launchpad.net/ubuntu/+source/qemu

Package: qemu
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Section: oldlibs
Depends: ${misc:Depends}
Description: fast processor emulator, dummy package
 QEMU is a fast processor emulator. Once upon a time there was only one
 package named `qemu', with all functionality included. These days, qemu
 become large and has been split into numerous packages. Different packages
 provides entirely different services, and it is very unlikely one will
 need all of them together. So current `qemu' package makes no sense anymore,
 and is becoming a dummy package.
 .
 If you want full system emulation of some architecture, install one or more
 of qemu-system-ARCH packages. If you want user-mode emulation, install
 qemu-user or qemu-user-static package. If you need utilities, use qemu-utils
 package.
 .
 This package can safely be removed.

Package: qemu-system
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Depends: ${misc:Depends},
 qemu-system-arm,
 qemu-system-mips,
 qemu-system-ppc,
 qemu-system-sparc,
 qemu-system-x86,
 qemu-system-s390x,
 qemu-system-misc
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This metapackage provides the full system emulation binaries for all supported
 targets, by depending on all per-architecture system emulation packages which
 QEMU supports.

Package: qemu-block-extra
Architecture: amd64 arm arm64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
         qemu-system-x86 (= ${binary:Version})
 |qemu-system-x86-xen (= ${binary:Version})
	|qemu-system-arm (= ${binary:Version})
	|qemu-system-mips (= ${binary:Version})
	|qemu-system-ppc (= ${binary:Version})
	|qemu-system-sparc (= ${binary:Version})
 |qemu-system-s390x (= ${binary:Version})
	|qemu-system-misc (= ${binary:Version})
	|qemu-utils (= ${binary:Version}),
Enhances: qemu-utils, qemu-system-misc,
 qemu-system-arm, qemu-system-mips, qemu-system-sparc, qemu-system-x86,
 qemu-system-x86-xen
Description: extra block backend modules for qemu-system and qemu-utils
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides extra block device backend modules for qemu-system
 emulation and qemu-img from qemu-utils package, which are rarely used and
 has extra dependencies.

Package: qemu-system-data
Architecture: all
Multi-Arch: foreign
Conflicts: sgabios, qemu-skiboot, openbios-sparc, openbios-ppc, qemu-slof,
Replaces: qemu-system-common (<< 1:2.12+dfsg-2~), sgabios,
  openbios-sparc, openbios-ppc, qemu-slof, qemu-system-sparc (<< 1:4.2-4~), qemu-system-ppc (<< 1:6.1-4~),
    qemu-system-s390x (<< 1:3.1+dfsg-2ubuntu1~)
Breaks: qemu-system-s390x (<< 1:3.1+dfsg-2ubuntu1~)
Provides: qemu-keymaps, sgabios, qemu-skiboot, openbios-sparc, openbios-ppc, qemu-slof,
Depends: ${misc:Depends}
Description: QEMU full system emulation (data files)
 This package provides architecture-neutral data files
 (such as keyboard definitions, icons) for system-mode
 QEMU emulation (qemu-system-*) packages.

Package: qemu-system-common
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: no
Replaces: qemu-system-data (<< 1:3.1+dfsg-1~), qemu-utils (<< 1:3.1+dfsg-3~)
Breaks:   qemu-system-data (<< 1:3.1+dfsg-1~), qemu-utils (<< 1:3.1+dfsg-3~), libvirt-daemon (<< 7.2.0-1)
Depends: ${misc:Depends}, ${shlibs:Depends},
# to fix wrong acl for newly created device node on ubuntu:
 acl
Description: QEMU full system emulation binaries (common files)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides common files needed for target-specific
 full system emulation (qemu-system-*) packages.

Package: qemu-system-gui
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
#XXX M-A: same does not really work for now due to /usr/lib/qemu/vhost-user-gpu
#XXX we'll deal with this if some actual need arises,
#XXX by moving that binary back to q-s-common or packaging it separately
#Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
         qemu-system-x86 (= ${binary:Version})
 |qemu-system-x86-xen (= ${binary:Version})
	|qemu-system-arm (= ${binary:Version})
	|qemu-system-mips (= ${binary:Version})
	|qemu-system-ppc (= ${binary:Version})
	|qemu-system-sparc (= ${binary:Version})
 |qemu-system-s390x (= ${binary:Version})
	|qemu-system-misc (= ${binary:Version}),
# libgl1 is dynamically loaded by sdl display code
        libgl1,
# we moved vhost-user-gpu files here from qemu-system-common at 6.1-4
Replaces: qemu-system-common (<< 1:6.1+dfsg-4~)
Description: QEMU full system emulation binaries (user interface and audio support)
 This package provides local graphical user interface (currently GTK)
 and audio backends for full system emulation (qemu-system-*) packages.
 .
 The default GTK based qemu-system-gui is generally better and recommended,
 but a few corner cases still need SDL which is therefore provided as well.

Package: qemu-system-misc
Architecture: amd64 arm arm64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel mips64 mips64el powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, qemu-system-common (= ${binary:Version}), qemu-system-data (>> ${source:Version}~),
Recommends: qemu-system-gui (= ${binary:Version}), qemu-utils,
# alpha uses vgabios
# alpha m68k sh4 uses bootroms
 seabios, ipxe-qemu,
 qemu-block-extra (= ${binary:Version}),
Suggests: samba, vde2,
Provides: ${sysprovides:misc}
Description: QEMU full system emulation binaries (miscellaneous)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, M68k (ColdFire), MicroBlaze, and SH4
 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:

# get DEB_VERSION
include /usr/share/dpkg/pkg-info.mk
# get DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_TYPE DEB_HOST_MULTIARCH DEB_BUILD_GNU_TYPE
include /usr/share/dpkg/architecture.mk

# Disable LTO on non-amd64 builds, see:
# https://bugs.launchpad.net/ubuntu/+source/qemu/+bug/1921664
# https://bugzilla.redhat.com/show_bug.cgi?id=1952483
# [jammy backport: export before include buildflags.mk;
#  binary-arch (configure) is not run in a child process (dh) as in
#  kinetic, so it needs the new/non-LTO $(CFLAGS) in this process.]
ifneq ($(DEB_HOST_ARCH),amd64)
  export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

# get CFLAGS LDFLAGS etc
include /usr/share/dpkg/buildflags.mk

libdir = /usr/lib/${DEB_HOST_MULTIARCH}

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
VENDOR := UBUNTU
DEB_BUILD_PARALLEL = yes
XENENABLED := --disable-xen
else
VENDOR := DEBIAN
XENENABLED := $(if $(filter $(DEB_HOST_ARCH),amd64 i386),--enable-xen,--disable-xen)
endif


# support parallel build using DEB_BUILD_OPTIONS=parallel=N
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# verbose build
V ?= 1

# list of packages we're supposed to build
BUILD_PACKAGES = $(call dpkg_late_eval,BUILD_PACKAGES,dh_listpackages)

enable_system = $(if $(filter qemu-system,${BUILD_PACKAGES}),enable,disable)
enable_linux_user = $(if $(filter qemu-user,${BUILD_PACKAGES}),enable,disable)

FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu
PKGVERSION = Debian ${DEB_VERSION}
SAVEMODDIR = /run/qemu/$(shell echo -n "${PKGVERSION}" | tr --complement '[:alnum:]+-.~' '_')
sysdatadir = debian/qemu-system-data/usr/share/qemu

ALPHAEV67_CROSSPFX = alpha-linux-gnu-
PPC64_CROSSPFX = powerpc64-linux-gnu-
RISCV64_CROSSPFX = riscv64-linux-gnu-

# we add another set of configure options from debian/control
common_configure_opts = \
	--with-pkgversion="$(PKGVERSION)" \
	--extra-cflags="$(CFLAGS) $(CPPFLAGS)" --extra-ldflags="$(LDFLAGS) -Wl,--as-needed" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=${libdir} \
	--libexecdir=/usr/lib/qemu \
	--firmwarepath=${FIRMWAREPATH} \
	--localstatedir=/var \
	--disable-install-blobs \
	--disable-strip \
	--interp-prefix=/etc/qemu-binfmt/%M \
	--localstatedir=/var \
	--with-git-submodules=ignore \

# Cross compiling support
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
common_configure_opts  += --cross-prefix=$(DEB_HOST_GNU_TYPE)-
endif

ifneq ($(filter $(DEB_TARGET_ARCH), alpha ia64 hppa m68k sh4 sparc), )
# allow configure to run on unsupported arches to build qemu-utils and the like
common_configure_opts += --enable-tcg-interpreter --enable-tools
endif

ifeq (${enable_system},enable)

# list of system (softmmu) targets, from ./configure
system_targets = \
 i386 x86_64 alpha aarch64 arm avr cris hppa m68k microblaze microblazeel \
 mips mipsel mips64 mips64el nios2 or1k ppc ppc64 riscv32 riscv64 rx \
 sh4 sh4eb sparc sparc64 s390x tricore xtensa xtensaeb

# qemu-system subpackages, from d/control
sys_systems = arm mips ppc sparc x86 $(if $(filter ${VENDOR},UBUNTU),s390x,)
systems = ${sys_systems} misc
sysarch_arm   = $(filter aarch64 arm,${system_targets})
sysarch_mips  = $(filter mips mipsel mips64 mips64el,${system_targets})
sysarch_ppc   = $(filter ppc ppc64,${system_targets})
sysarch_sparc = $(filter sparc sparc64,${system_targets})
sysarch_x86   = $(filter i386 x86_64,${system_targets})
sysarch_s390x = $(filter s390x,${system_targets})
sysarch_misc  = $(filter-out $(foreach s,${sys_systems},${sysarch_$s}),${system_targets})

else

systems =

endif # enable_system

ifeq (${enable_linux_user},enable)

# list of linux-user targets, from ./configure
user_targets = \
 i386 x86_64 alpha aarch64 aarch64_be arm armeb cris hexagon hppa m68k microblaze microblazeel \
 mips mipsel mips64 mips64el mipsn32 mipsn32el nios2 or1k \
 ppc ppc64 ppc64le riscv32 riscv64 sh4 sh4eb sparc sparc64 sparc32plus \
 s390x xtensa xtensaeb

endif	# enable_linux_user

sysdata-components :=
qemu-builds :=

# several builds of qemu binary:

##############################################
# regular, main system/user and tools build
configure-qemu: b/qemu/configured
b/qemu/configured: configure
	rm -rf b/qemu; mkdir -p b/qemu
	cd b/qemu && \
	    ../../configure ${common_configure_opts} --disable-user \
		--${enable_system}-system \
		--${enable_linux_user}-linux-user \
		${XENENABLED} \
		--enable-modules \
		--enable-module-upgrades \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		${QEMU_CONFIGURE_OPTIONS}
	touch $@

build-qemu: b/qemu/built
b/qemu/built: b/qemu/configured
	$(MAKE) -C b/qemu V=${V}
	touch $@

define inst-system
	mkdir -p debian/qemu-system-$1/usr/share/man/man1 debian/qemu-system-$1/usr/bin
	for t in ${sysarch_$1}; do \
	    mv debian/tmp/usr/bin/qemu-system-$$t debian/qemu-system-$1/usr/bin/qemu-system-$$t; \
	    echo ".so man1/qemu-system.1" > debian/qemu-system-$1/usr/share/man/man1/qemu-system-$$t.1; \
	done
	echo sysarch:$1=\
$(if $(wordlist 10,20,${sysarch_$1}),\
$(wordlist 1,8,${sysarch_$1})\$${Newline}   $(wordlist 9,20,${sysarch_$1}),\
${sysarch_$1}) \
> debian/qemu-system-$1.substvars
	echo sysprovides:$1=${addprefix qemu-system-,${filter-out $1,${sysarch_$1}}} | \
	  sed -e 's/ /, /g' -e 'y/_/-/' >> debian/qemu-system-$1.substvars
	dh_link -pqemu-system-$1 usr/share/doc/qemu-system-common usr/share/doc/qemu-system-$1/common

endef
# inst-kvm-link package binary-suffix
define inst-kvm-link
	dh_link -p $1 usr/bin/qemu-system-$2 usr/bin/kvm
	mkdir -p debian/$1/usr/share/man/man1
	sed 's/@ARCH@/$2/g' debian/kvm.1 > debian/$1/usr/share/man/man1/kvm.1
	touch -r debian/kvm.1 debian/$1/usr/share/man/man1/kvm.1
endef

install-qemu: b/qemu/built
	$(MAKE) -C b/qemu DESTDIR=$(CURDIR)/debian/tmp install \
	  KEYMAPS= ICON_SIZES=

# save block-extra loadable modules on upgrades
# other module types for now (5.0) can't be loaded at runtime, only at startup
	echo 'case $$1 in (upgrade|deconfigure) [ -d /run/qemu ] || exit 0; ! findmnt --noheadings --target /run/qemu/ | grep -q noexec || exit 0; mkdir -p ${SAVEMODDIR}; cp -p ${libdir}/qemu/block-*.so ${SAVEMODDIR}/;; esac' \
	  >> debian/qemu-block-extra.prerm.debhelper
	echo 'case $$1 in (remove) rm -f ${SAVEMODDIR}/block-*.so;; esac' \
	  >> debian/qemu-block-extra.postrm.debhelper
	echo 'case $$1 in (purge) if systemctl is-active -q run-qemu.mount; then systemctl stop run-qemu.mount || true; fi; rm -rf "/run/qemu";; esac' \
	  >> debian/qemu-block-extra.postrm.debhelper

ifeq (${enable_system},enable)

	# qemu-system subpackages
	mv debian/tmp/usr/share/man/man1/qemu.1 debian/tmp/usr/share/man/man1/qemu-system.1
	$(foreach s,${systems},$(call inst-system,$s))

# gui modules. We move these here instead of using d/qemu-system-gui.install,
# b/c we install "all other" modules in qemu-system-common.install
# audio-pa.so pulls in X11 so we move it into -system-gui too
# hw-display-virtio-gpu-gl also pulls in X11, move it to -gui
	mkdir -p debian/qemu-system-gui${libdir}/qemu
	mv -t debian/qemu-system-gui${libdir}/qemu/ \
		debian/tmp${libdir}/qemu/ui-gtk.so \
		debian/tmp${libdir}/qemu/ui-sdl.so \
		debian/tmp${libdir}/qemu/audio-jack.so \
		debian/tmp${libdir}/qemu/audio-sdl.so \
		debian/tmp${libdir}/qemu/audio-pa.so \
		debian/tmp${libdir}/qemu/hw-display-virtio-gpu-gl.so \

ifeq ($(DEB_HOST_ARCH_OS),linux)

# /usr/bin/kvm handy link multi-arch from old qemu-kvm package
# on i386, should we link to qemu-system-i386? how about x32?
ifneq ($(filter ${DEB_HOST_ARCH},amd64 i386),)
	$(call inst-kvm-link,qemu-system-x86,x86_64)
ifeq (${VENDOR},UBUNTU)

=== debian/watch ===
version=4

opts=\
dversionmangle=auto,\
repacksuffix=+dfsg,\
uversionmangle=s/-rc/~rc/;s/(\d+)\.(\d+)\.(\d+)/$1.$2/g,\
compression=xz \
  https://download.qemu.org/ qemu-@ANY_VERSION@@ARCHIVE_EXT@
